package com.burtbeckwith.binaryartifacts.test

// callback closures that are traditionally in the plugin descriptor
class PluginStub {

	def doWithWebDescriptor = { xml ->
		println "\ndoWithWebDescriptor $delegate $xml\n"

		def filterMapping = xml.'filter-mapping'
		filterMapping[filterMapping.size() - 1] + {
			'listener' {
				'listener-class'(ContextListener.name)
			}
		}
	}

	def doWithSpring = {
		println "\ndoWithSpring $delegate\n"

		hashMapBean(HashMap)
	}

	def doWithDynamicMethods = { ctx ->
		println "\ndoWithDynamicMethods $delegate $ctx\n"

		String.metaClass.bark = { -> delegate + ' says WOOF!' }
	}

	def doWithApplicationContext = { ctx ->
		println "\ndoWithApplicationContext $delegate $ctx\n"

		ctx.hashMapBean.foo = 'bar'
	}

	def onConfigChange = { event ->
		println "\nonConfigChange $delegate $event\n"
	}
}
